
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string Name_Expert            = "Ichimoku Nrtr";
extern bool   EcnBroker              = true;
extern bool   NoHedge                = true;
extern bool   StrictNoHedge          = true;
extern bool   UseAutoMagic           = true;
extern int    ManualMagic            = 17171717;  
extern double lStopLoss              = 60;
extern double sStopLoss              = 60;
extern double lTakeProfit            = 12;
extern double sTakeProfit            = 12;
extern double lTrailingStop          = 0;
extern double sTrailingStop          = 0;
extern int    Slippage               = 4;
extern double Lots                   = 0.1;
extern double MaximumRisk            = 0;
extern double DecreaseFactor         = 3;

extern int    ichTf                  = 0;
extern int    Tenkan                 = 72;
extern int    Kijun                  = 144;
extern int    Senkou                 = 288;
extern int    ichTf2                 = 0;
extern int    Tenkan2                = 72;
extern int    Kijun2                 = 144;
extern int    Senkou2                = 288;
extern int    ichibar                = 1;  // best to keep at 0 because using kijun setting as shift 
extern int    Kijunshift             = 143;
extern int    bar                    = 1; // close bar figured with ichimoku

extern int    ATRPeriod              = 14;
extern double Coefficient            = 4.0;
extern int    StartBar               = 1000;
extern int    nrtrbar                = 1;

extern string __                     = "Psar Filter";
extern bool   UsePsar                = true;
extern double AccStep                = 0.02;
extern double AccLimit               = 0.2;
extern int    PriceHigh              = PRICE_HIGH;
extern int    PriceLow               = PRICE_LOW;
extern int    sarbar                 = 1;

extern string ____                   = "Rsi Filter";
extern bool   UseRsi                 = false;
extern int    PeriodRSI              = 7;
extern int    Price                  = 0;
extern double levelOb                = 70;
extern double levelOs                = 30;
extern int    rsibar                 = 1;

extern string _____                  = "Regular Rsi Filter";
extern bool   UseRegularRsi          = false;  // true or false to use regular rsi overbought or oversold
extern double reglevelOb             = 70;
extern double reglevelOs             = 30;

extern bool   UseIchimokuClose       = false;
extern int    cl.ichTf               = 0;
extern int    cl.Tenkan              = 9;
extern int    cl.Kijun               = 26;
extern int    cl.Senkou              = 52;
extern int    cl.bar                 = 1;
extern int    cl.Kijunshift          = 0;

extern string  ____TimeFilter        = "Time filter settings";
extern string  Trade.startFrom       = "00:00";
extern string  Trade.endAt           = "24:00";

extern string __fricl                = "Setting for friday positions close";
extern bool   CloseOnFriday          = false;
extern int    FridayCloseHour        = 21; // will be used only if CloseOnFriday == true
extern int    FridayCloseMinute      = 59; // will be used only if CloseOnFriday == true

extern bool   ShowAlerts             = false;
extern color  clOpenBuy              = Blue;
extern color  clCloseBuy             = Aqua;
extern color  clOpenSell             = Red;
extern color  clCloseSell            = Violet;

//
//
//
//
//

string s_symbol;

int    MAGIC;
int    digit;

double point = 1;

//
//
//
//
//

int init() 
{
  s_symbol = Symbol();
  
  digit  = MarketInfo(s_symbol,MODE_DIGITS);
  if (digit==2 || digit==4) point = 1;
  if (digit==3 || digit==5) point = 10;
  if (digit==6)             point = 100;
  
  if (UseAutoMagic) MAGIC = GetMagic();
              else  MAGIC = ManualMagic;  
              
return(0);
}

//
//
//
//
//

int deinit() { Comment(""); return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   
   if(Bars < 100) { Print("bars less than 100"); return(0); }
   
   //
   //
   //
   //
   //
   
   bool canEnterNewTrade = true;
   if (canEnterNewTrade)
   {
      string     st1 = normalizeTime(Trade.startFrom);
      string     et1 = normalizeTime(Trade.endAt);
      datetime   ts1 = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+st1); datetime ts2 = ts1;
      datetime   te1 = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+et1); datetime te2 = te1;
      if (te1<ts1) { ts1 -= 24*60*60; te2 += 24*60*60; }
        canEnterNewTrade = ((TimeCurrent()>=ts1 && TimeCurrent()<=te1) || (TimeCurrent()>=ts2 && TimeCurrent()<=te2));
   }
   
   //
   //
   //
   //
   //
   
   if (CloseOnFriday && TimeDayOfWeek(TimeCurrent())==5)
   {
     if (TimeHour(TimeCurrent()) > FridayCloseHour ||
        (TimeHour(TimeCurrent())== FridayCloseHour && TimeMinute(TimeCurrent())>= FridayCloseMinute))
     {
       for(int i=OrdersTotal()-1; i>=0; i--)
  	    { 
     	   OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol()     != s_symbol)    continue;
            if(OrderMagicNumber()!= MAGIC)       continue;

            if(OrderType()==OP_BUY)      { OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE); continue; }
            if(OrderType()==OP_SELL)     { OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE); continue; }
       }
       return(0);
     }
   }
   
   //
   //
   //
   //
   //
   
   double senkouspananow  = iIchimoku(s_symbol, ichTf,Tenkan, Kijun, Senkou, MODE_SENKOUSPANA,ichibar+Kijunshift);
   double senkouspanbnow  = iIchimoku(s_symbol, ichTf,Tenkan, Kijun, Senkou, MODE_SENKOUSPANB,ichibar+Kijunshift);
   double senkouspana2now = iIchimoku(s_symbol,ichTf2,Tenkan2,Kijun2,Senkou2,MODE_SENKOUSPANA,ichibar+Kijunshift);
   double senkouspanb2now = iIchimoku(s_symbol,ichTf2,Tenkan2,Kijun2,Senkou2,MODE_SENKOUSPANB,ichibar+Kijunshift);
   
   double blueNrtrNow = iCustom(s_symbol,0,"NRTR_color_line",ATRPeriod,Coefficient,StartBar,0,nrtrbar);
   double redNrtrNow  = iCustom(s_symbol,0,"NRTR_color_line",ATRPeriod,Coefficient,StartBar,1,nrtrbar);
   double blueNrtrPre = iCustom(s_symbol,0,"NRTR_color_line",ATRPeriod,Coefficient,StartBar,0,nrtrbar+1);
   double redNrtrPre  = iCustom(s_symbol,0,"NRTR_color_line",ATRPeriod,Coefficient,StartBar,1,nrtrbar+1);
   
   double rsinow      = iCustom(s_symbol,0,"rsi",PeriodRSI,Price,0,rsibar);
   double rsipre      = iCustom(s_symbol,0,"rsi",PeriodRSI,Price,0,rsibar+1);
   
   double sarupnow    = iCustom(s_symbol,0,"Parabolic SAR 2",AccStep,AccLimit,PriceHigh,PriceLow,true,0,sarbar);
   double saruppre    = iCustom(s_symbol,0,"Parabolic SAR 2",AccStep,AccLimit,PriceHigh,PriceLow,true,0,sarbar+1);
   double sardnnow    = iCustom(s_symbol,0,"Parabolic SAR 2",AccStep,AccLimit,PriceHigh,PriceLow,true,1,sarbar);
   double sardnpre    = iCustom(s_symbol,0,"Parabolic SAR 2",AccStep,AccLimit,PriceHigh,PriceLow,true,1,sarbar+1);
   
   //
   //
   //
   //
   //
   
   if (UseRegularRsi)
   {
   
     bool belowreglevelOs = (rsinow >= reglevelOs && rsipre < reglevelOs);
     bool abovereglevelOb = (rsinow <= reglevelOb && rsipre > reglevelOb);
   }
   else      
   {
         belowreglevelOs = true;
         abovereglevelOb = true;
   }
   
   if (UseRsi)
   {
     bool abovelevelOb = (rsinow > rsipre && rsinow > levelOb);
     bool belowlevelOs = (rsinow < rsipre && rsinow < levelOs);
   }
   else      
   {
         abovelevelOb = true;
         belowlevelOs = true;
   }

   if (UsePsar)
   {
     bool bullsar = (sarupnow!=EMPTY_VALUE && sardnnow==EMPTY_VALUE && sarupnow > saruppre);
     bool bearsar = (sarupnow==EMPTY_VALUE && sardnnow!=EMPTY_VALUE && sardnnow < sardnpre);
   }
   else      
   {
         bullsar = true;
         bearsar = true;
   }
   
   //
   //
   //
   //
   //
   
   if (!ExistPositions() && canEnterNewTrade)
   {
      
     if (Close[bar] > MathMax(senkouspananow,senkouspanbnow) && Close[bar] > MathMax(senkouspana2now,senkouspanb2now) && 
         blueNrtrNow > 0 && blueNrtrPre==0 && belowreglevelOs && abovelevelOb && bullsar && canOpen(OP_BUY)) 
     {
       OpenBuy();
       return(0);
     }

     if (Close[bar] < MathMin(senkouspananow,senkouspanbnow) && Close[bar] < MathMin(senkouspana2now,senkouspanb2now) && 
         redNrtrNow > 0 && redNrtrPre==0 && abovereglevelOb && belowlevelOs && bearsar && canOpen(OP_SELL)) 
     {
       OpenSell();
       return(0);
     }
      
   }
   
   if(lTrailingStop > 0) TrailingPositionsBuy();
   if(sTrailingStop > 0) TrailingPositionsSell();
   if(UseIchimokuClose) CheckForClose();
   
   return (0);
}

//
//
//
//
//

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) {
				return(true);
			}
		} 
   }
return(false);
}

//
//
//
//
//

void TrailingPositionsBuy() { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
               if (Bid-OrderOpenPrice()     > lTrailingStop * Point * point) { 
                  if (OrderStopLoss() < Bid - lTrailingStop * Point * point) 
                      ModifyStopLoss(Bid    - lTrailingStop * Point * point); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell() { 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
               if (OrderOpenPrice() - Ask   > sTrailingStop * Point * point) { 
                  if (OrderStopLoss() > Ask + sTrailingStop * Point * point || OrderStopLoss() == 0)  
                      ModifyStopLoss(Ask    + sTrailingStop * Point * point); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
   
   if (fm == false)
   {
	  int    ErrorCode = GetLastError();
	  string ErrDesc   = ErrorDescription(ErrorCode);

	  string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
	  if (ShowAlerts   == true) Alert(ErrAlert);

	  string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
	  Print(ErrLog);
	}
 
} 

//
//
//
//
//

void OpenBuy() 
{ 
    
   if (lStopLoss > 0)   double lbStop = Ask - lStopLoss   * Point * point; 
   else lbStop = 0;
   
   if (lTakeProfit > 0) double lbTake = Ask + lTakeProfit * Point * point;
   else lbTake = 0;
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*Point*point,lbStop,lbTake,Name_Expert,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),Ask,Slippage*Point*point,0,0,Name_Expert,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket   >= 0)
         bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),lbStop,lbTake,0,CLR_NONE);
         
         if (buyOrderMod  == false)
         {
         
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Buy Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",buyTicket," Stop: ",lbStop," Profit: ",lbTake);
           Print(ErrLog);
         }
    }		       

}

//
//
//
//
//

void OpenSell() 
{ 

   if (sStopLoss > 0)   double lsStop = Bid + sStopLoss   * Point * point; 
   else lsStop = 0;
   
   if (sTakeProfit > 0) double lsTake = Bid - sTakeProfit * Point * point;
   else lsTake = 0;
  
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*Point*point,lsStop,lsTake,Name_Expert,MAGIC,0,clOpenSell); 
   else
   {
         int sellTicket    = OrderSend(s_symbol,OP_SELL,LotsOptimized(),Bid,Slippage*Point*point,0,0,Name_Expert,MAGIC,0,clOpenSell);		    		    
         if (sellTicket    >= 0)
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),lsStop,lsTake,0,CLR_NONE);
         
         if (sellOrderMod  == false)
         {
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Sell Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",Ask," Bid: ",Bid," Ticket: ",sellTicket," Stop: ",lsStop," Profit: ",lsTake);
           Print(ErrLog);
         }
    }		       
} 

//
//
//
//
//

void CheckForClose()  
{
   RefreshRates();
   double clsenkouspananow = iIchimoku(s_symbol,cl.ichTf,cl.Tenkan,cl.Kijun,cl.Senkou,MODE_SENKOUSPANA,cl.bar+cl.Kijunshift);
   double clsenkouspanbnow = iIchimoku(s_symbol,cl.ichTf,cl.Tenkan,cl.Kijun,cl.Senkou,MODE_SENKOUSPANB,cl.bar+cl.Kijunshift);
   
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= MAGIC)                         continue;
      if (OrderSymbol()     != s_symbol)                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (Close[bar] < MathMin(clsenkouspananow,clsenkouspanbnow)) 
        {
           bool buyClose = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*Point*point,clCloseBuy);
           if (buyClose == false)
           {
             int ErrorCode   = GetLastError();
             string ErrDesc  = ErrorDescription(ErrorCode);

             string ErrAlert = StringConcatenate("Close Buy Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts  == true) Alert(ErrAlert);

             string ErrLog   = StringConcatenate("Bid: ",Bid," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
           }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (Close[bar] > MathMax(clsenkouspananow,clsenkouspanbnow)) 
        {
          bool sellClose = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*Point*point,clCloseSell); 
          if (sellClose  == false)
          {
             ErrorCode = GetLastError();
             ErrDesc   = ErrorDescription(ErrorCode);

             ErrAlert  = StringConcatenate("Close Sell Order - Error ",ErrorCode,": ",ErrDesc);
             if (ShowAlerts == true) Alert(ErrAlert);

             ErrLog   = StringConcatenate("Ask: ",Ask," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
             Print(ErrLog);
          }
        }
        break;
      }
   }
}

//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(s_symbol,MODE_MINLOT);
   double lot_max  = MarketInfo(s_symbol,MODE_MAXLOT);
   double lot_step = MarketInfo(s_symbol,MODE_LOTSTEP);
   double contract = MarketInfo(s_symbol,MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
   
return(lot);
} 

//
//
//
//
//

bool canOpen(int openWhat)
{
   if (!NoHedge) return(true);

   //
   //
   //
   //
   //
      
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if (OrderSymbol() != s_symbol)                       continue;
      if (!StrictNoHedge && OrderMagicNumber() != MAGIC)   continue;
      
      if (OrderType() == OP_BUY  && openWhat == OP_SELL)   return(false); 
      if (OrderType() == OP_SELL && openWhat == OP_BUY)    return(false); 
   }      
   return(true);
}

//----------------------------------------------------------------------------------------
//           
//----------------------------------------------------------------------------------------
//
//
//
//
//

string normalizeTime(string time)
{
   int sepAt  = StringFind(time,":",0);
   int hour   = StrToInteger(StringSubstr(time,0,sepAt));
   int minute = StrToInteger(StringSubstr(time,sepAt+1,0));
   
   //
   //
   //
   //
   //
   
   hour   = MathMax(MathMin(hour  ,24),0);
   minute = MathMax(MathMin(minute,59),0);
   string answer="";
      while(true)
      {
         if (hour==0) { answer="00";     break; }
         if (hour<10) { answer="0"+hour; break; }
                        answer=    hour; break; 
      }                        
      while(true)
      {
         if (minute==0) { answer=answer+":00";       break; }
         if (minute<10) { answer=answer+":0"+minute; break; }
                          answer=answer+":" +minute; break; 
      }
   return(" "+answer); 
}

//
//
//
//
//

int GetMagic() 
{

   if (StringFind(s_symbol, "CADJPY") >= 0) return(1933921);
   if (StringFind(s_symbol, "CADCHF") >= 0) return(1933922);
   
   if (StringFind(s_symbol, "GOLD"  ) >= 0) return(1933931);
   if (StringFind(s_symbol, "SILVER") >= 0) return(1933932);
   
   if (StringFind(s_symbol, "NZDJPY") >= 0) return(1933941);
   if (StringFind(s_symbol, "NZDUSD") >= 0) return(1933942);
   
   if (StringFind(s_symbol, "CHFJPY") >= 0) return(1933951);
   
   if (StringFind(s_symbol, "EURAUD") >= 0) return(1933961);
   if (StringFind(s_symbol, "EURCAD") >= 0) return(1933962);
   if (StringFind(s_symbol, "EURUSD") >= 0) return(1933963);
   if (StringFind(s_symbol, "EURGBP") >= 0) return(1933964);
   if (StringFind(s_symbol, "EURCHF") >= 0) return(1933965);
   if (StringFind(s_symbol, "EURNZD") >= 0) return(1933966);
   if (StringFind(s_symbol, "EURJPY") >= 0) return(1933967);
   
   if (StringFind(s_symbol, "GBPUSD") >= 0) return(1933971);
   if (StringFind(s_symbol, "GBPCHF") >= 0) return(1933972);
   if (StringFind(s_symbol, "GBPJPY") >= 0) return(1933973);
   
   if (StringFind(s_symbol, "USDCHF") >= 0) return(1933981);
   if (StringFind(s_symbol, "USDJPY") >= 0) return(1933982);
   if (StringFind(s_symbol, "USDCAD") >= 0) return(1933983);

   if (StringFind(s_symbol, "AUDUSD") >= 0) return(1933991);
   if (StringFind(s_symbol, "AUDNZD") >= 0) return(1933992);
   if (StringFind(s_symbol, "AUDCAD") >= 0) return(1933993);
   if (StringFind(s_symbol, "AUDCHF") >= 0) return(1933994);
   if (StringFind(s_symbol, "AUDJPY") >= 0) return(1933995);
   
return(ManualMagic);
}



